commit:     eadde0e546a2101c4499b78a4f0847ee5f8f7810
Author:     Alfred Wingate <parona <AT> protonmail <DOT> com>
AuthorDate: Fri Jan  9 11:03:57 2026 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Sat Jan 10 12:10:42 2026 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=eadde0e5

dev-db/mongodb: add 7.0.28

Bug: https://bugs.gentoo.org/968160
Signed-off-by: Alfred Wingate <parona <AT> protonmail.com>
Part-of: https://github.com/gentoo/gentoo/pull/45318
Closes: https://github.com/gentoo/gentoo/pull/45318
Signed-off-by: Sam James <sam <AT> gentoo.org>

 dev-db/mongodb/Manifest                            |   1 +
 .../mongodb/files/mongodb-7.0.28-sconstruct.patch  | 110 +++++++++++
 dev-db/mongodb/mongodb-7.0.28.ebuild               | 210 +++++++++++++++++++++
 3 files changed, 321 insertions(+)

diff --git a/dev-db/mongodb/Manifest b/dev-db/mongodb/Manifest
index 088a0f8453f8..f4c8a585f8e9 100644
--- a/dev-db/mongodb/Manifest
+++ b/dev-db/mongodb/Manifest
@@ -9,6 +9,7 @@ DIST mongodb-6.0.27.gh.tar.gz 87528963 BLAKE2B 
b0155e5caaff1f7532291a64d723a6cff
 DIST mongodb-7.0.18-patches.tar.xz 9036 BLAKE2B 
d52032a7bd82a5bffd3536a14d346750b9c093387dd5cb2cf618e32410ccc22e3c5e89a4947d948c16dc8fa4c34388b7ffcc3321723dfa2b2730db763acc2f69
 SHA512 
5e6e5b29a2c500e6be7fb3e9b83a5f88fde0182e070af15e4d04dede82a6cea8957e1fc0ea329f0cd8a51565de9e51c7ae1d0e7f2ca021e5391cabb337752d40
 DIST mongodb-7.0.18.gh.tar.gz 87225100 BLAKE2B 
7ede32f4c6b6968ee8d797ce71457133020a3e4a039cd0db914e344e5042a0b871deb5741f86098b2e82b9ff619a511a754a06a29dcbb9527a3b7a7edf52b3ac
 SHA512 
599767db66e95d8dd0bd0e6d51fd70129ea6df1e18a0cdaa52bc6cbe301c982684ff5aab446c50cb825573051e372d8f791aeab7df58e2a4d855e6073f2b46d5
 DIST mongodb-7.0.23.gh.tar.gz 87871275 BLAKE2B 
3f99dfd79a04c110e0f79f3e91ceda40e31bdb171c07d1d3323c55c3bf2b5c0bdca34803bbd1c083568c1c70b2796d427fc356b520c28eaa1f671f0fd9183bd2
 SHA512 
9c73a1b70f8537c5106b06733363c45d7cab1b50af60e157dc9dd0aa6834cad3bf63e9935c5b0a61b5635bbf5db22d6ec0a337d72344118582834b4dc37e6b81
+DIST mongodb-7.0.28.gh.tar.gz 90762731 BLAKE2B 
d60babc4c5b823b9b55b086b34cc2ced41187c08c3a591265307ffde6bb5bf56ede6ca1b273b9fa0baa5da475820b837db1d43bf0fd1be46e5ad07a8d9b91f21
 SHA512 
1e8e782ea1f89bc2e3e0b5d15b6f5c9479cda35c8e64fb5d91a3750880eb10274b15ab3f04118dfceb15a18cbedd3c4026826ea2f38f1864d5d26626ac177339
 DIST mongodb-8.0.12.gh.tar.gz 98534080 BLAKE2B 
6d9abd2ea31d5890f4b1f0cb3e0346d2c89169b3b9239104c2360bd1b52fab599570bafaf225be744bd3d94e025d21f5afc36fea47a7e49963339ba20c17ae22
 SHA512 
0bbf8d750a6f33dd7758158fb83624d3b9691c682086d9725df8cb1973642f6a64d6155f5501d01a8344a5304190fc9e2c4eb6179a6ead3cd305c1098b756648
 DIST mongodb-8.0.8-patches.tar.xz 8076 BLAKE2B 
860c76266f7db7de846c7a791c8a0eb680b0587f6600e6d71bcaae666dda12073fb3613bfe768aa042b54081287b271cb91f4f8c4d5c9232ce7f318ffcff08bb
 SHA512 
c9d96fd16d7790ec459ac839be4aa0076d48e936abdd80e910d1ebc6010652c43291f69e379dd4322f76276c8bb2072c52977e7f30a36d92efbda1161f9a5a13
 DIST mongodb-8.0.8.gh.tar.gz 94643838 BLAKE2B 
c559af9f3b2d1a3ad7139cd9476114bd6c990a1269f4dedf3010118c5e182689703c731ca04fba0bcce91c4f05c521fbbf0556c8b76af27fa10298f0258b5921
 SHA512 
28fb8455ae4290f9f704e69fcc78c939751ed95a4cbff6f6af55786a10606c1431f9c450b343486bc7b21177b0a3dab04fe088a76a9b8740a207e2cd770cd5eb

diff --git a/dev-db/mongodb/files/mongodb-7.0.28-sconstruct.patch 
b/dev-db/mongodb/files/mongodb-7.0.28-sconstruct.patch
new file mode 100644
index 000000000000..e622834fb0e3
--- /dev/null
+++ b/dev-db/mongodb/files/mongodb-7.0.28-sconstruct.patch
@@ -0,0 +1,110 @@
+wrt PATH:
+"""
+https://jira.mongodb.org/browse/SERVER-94430 Upstream respond:
+
+> we intentionally do not ingest the environment PATH as this makes build
+> reproducibility and hermiticity much harder. Instead, you should set the
+> absolute paths to the tools you want to use on the command line, instead of
+> relying on the PATH.
+
+Gentoo bug https://bugs.gentoo.org/829340
+
+In Gentoo, we have LLVM slotted and we put clang in /usr/lib/llvm/18/bin (or
+whatever), not in /usr/bin, and if upstream strip PATH and construct it
+themselves, they surely won't contain this location.
+
+So we add PATH backup for scons.
+"""
+diff --git a/SConstruct b/SConstruct
+index 2ebeb0e..44ce93a 100644
+--- a/SConstruct
++++ b/SConstruct
+@@ -3034,7 +3026,6 @@ if env.TargetOSIs('posix'):
+     env.Append(
+         CCFLAGS=[
+             "-fasynchronous-unwind-tables",
+-            "-g2" if not env.TargetOSIs('emscripten') else "-g",
+             "-Wall",
+             "-Wsign-compare",
+             "-Wno-unknown-pragmas",
+@@ -3101,6 +3092,8 @@ if env.TargetOSIs('posix'):
+ 
+     # env.Append( " -Wconversion" ) TODO: this doesn't really work yet
+     env.Append(CXXFLAGS=["-Woverloaded-virtual"])
++    env.Append(CXXFLAGS=os.environ['CXXFLAGS'])
++    env.Append(LINKFLAGS=os.environ['LDFLAGS'])
+ 
+     # On OS X, clang doesn't want the pthread flag at link time, or it
+     # issues warnings which make it impossible for us to declare link
+@@ -3151,7 +3144,7 @@ if env.TargetOSIs('posix'):
+         ], )
+ 
+     #make scons colorgcc friendly
+-    for key in ('HOME', 'TERM'):
++    for key in ('HOME', 'TERM', 'PATH'):
+         try:
+             env['ENV'][key] = os.environ[key]
+         except KeyError:
+@@ -3553,33 +3546,6 @@ def doConfigure(myenv):
+         myenv.AddMethod(
+             functools.partial(var_func, var=var, func=CheckFlag), 
f"Check{var}Supported")
+ 
+-    if myenv.ToolchainIs('gcc', 'clang'):
+-        # This tells clang/gcc to use the gold linker if it is available - we 
prefer the gold linker
+-        # because it is much faster. Don't use it if the user has already 
configured another linker
+-        # selection manually.
+-        if any(flag.startswith('-fuse-ld=') for flag in env['LINKFLAGS']):
+-            myenv.FatalError(
+-                f"Use the '--linker' option instead of modifying the 
LINKFLAGS directly.")
+-
+-        linker_ld = get_option('linker')
+-        if linker_ld == 'auto':
+-            if not env.TargetOSIs('darwin', 'macOS'):
+-                if not myenv.AddToLINKFLAGSIfSupported('-fuse-ld=lld'):
+-                    myenv.FatalError(
+-                        f"The recommended linker 'lld' is not supported with 
the current compiler configuration, you can try the 'gold' linker with 
'--linker=gold'."
+-                    )
+-        elif link_model.startswith("dynamic") and linker_ld == 'bfd':
+-            # BFD is not supported due to issues with it causing warnings 
from some of
+-            # the third party libraries that mongodb is linked with:
+-            # https://jira.mongodb.org/browse/SERVER-49465
+-            myenv.FatalError(f"Linker {linker_ld} is not supported with 
dynamic link model builds.")
+-        else:
+-            if not myenv.AddToLINKFLAGSIfSupported(f'-fuse-ld={linker_ld}'):
+-                myenv.FatalError(f"Linker {linker_ld} could not be 
configured.")
+-
+-        if has_option('gcov') and 
myenv.AddToCCFLAGSIfSupported('-fprofile-update=single'):
+-            myenv.AppendUnique(LINKFLAGS=['-fprofile-update=single'])
+-
+     detectCompiler = Configure(
+         myenv,
+         help=False,
+@@ -5119,17 +5085,13 @@ def doConfigure(myenv):
+         "BOOST_LOG_NO_SHORTHAND_NAMES",
+         "BOOST_LOG_USE_NATIVE_SYSLOG",
+         "BOOST_LOG_WITHOUT_THREAD_ATTR",
++        "BOOST_LOG_DYN_LINK",
+         "BOOST_MATH_NO_LONG_DOUBLE_MATH_FUNCTIONS",
+         "BOOST_SYSTEM_NO_DEPRECATED",
+         "BOOST_THREAD_USES_DATETIME",
+         ("BOOST_THREAD_VERSION", "5"),
+     ])
+ 
+-    if link_model.startswith("dynamic") and not link_model == 'dynamic-sdk':
+-        conf.env.AppendUnique(CPPDEFINES=[
+-            "BOOST_LOG_DYN_LINK",
+-        ])
+-
+     if use_system_version_of_library("boost"):
+         if not conf.CheckCXXHeader("boost/filesystem/operations.hpp"):
+             myenv.ConfError("can't find boost headers")
+@@ -5326,6 +5288,9 @@ def doConfigure(myenv):
+ 
+     mongoc_mode = get_option('use-system-mongo-c')
+     conf.env['MONGO_HAVE_LIBMONGOC'] = False
++    conf.env.ParseConfig('pkg-config libbson-1.0 libmongoc-1.0 --cflags')
++    conf.env['LIBDEPS_LIBBSON_SYSLIBDEP'] = 'bson-1.0'
++
+     if mongoc_mode != 'off':
+         if conf.CheckLibWithHeader(
+             ["mongoc-1.0"],

diff --git a/dev-db/mongodb/mongodb-7.0.28.ebuild 
b/dev-db/mongodb/mongodb-7.0.28.ebuild
new file mode 100644
index 000000000000..cdd75e5e8604
--- /dev/null
+++ b/dev-db/mongodb/mongodb-7.0.28.ebuild
@@ -0,0 +1,210 @@
+# Copyright 1999-2026 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+PYTHON_COMPAT=( python3_{11..14} )
+
+SCONS_MIN_VERSION="3.3.1"
+CHECKREQS_DISK_BUILD="2400M"
+CHECKREQS_DISK_USR="512M"
+CHECKREQS_MEMORY="1024M"
+
+inherit check-reqs eapi9-ver flag-o-matic multiprocessing pax-utils 
python-any-r1 scons-utils systemd toolchain-funcs
+
+MY_PV=r${PV/_rc/-rc}
+MY_P=mongo-${MY_PV}
+
+DESCRIPTION="A high-performance, open source, schema-free document-oriented 
database"
+HOMEPAGE="https://www.mongodb.com";
+SRC_URI="https://github.com/mongodb/mongo/archive/refs/tags/${MY_PV}.tar.gz -> 
${P}.gh.tar.gz"
+SRC_URI+=" 
https://dev.gentoo.org/~sam/distfiles/${CATEGORY}/${PN}/${PN}-7.0.18-patches.tar.xz";
+S="${WORKDIR}/${MY_P}"
+
+LICENSE="Apache-2.0 SSPL-1"
+SLOT="0"
+KEYWORDS="~amd64 ~arm64 -riscv"
+CPU_FLAGS="cpu_flags_x86_avx"
+IUSE="debug kerberos mongosh ssl +tools ${CPU_FLAGS}"
+
+# https://github.com/mongodb/mongo/wiki/Test-The-Mongodb-Server
+# resmoke needs python packages not yet present in Gentoo
+RESTRICT="test"
+
+RDEPEND="acct-group/mongodb
+       acct-user/mongodb
+       >=app-arch/snappy-1.1.7:=
+       app-arch/zstd:=
+       >=dev-cpp/yaml-cpp-0.6.2:=
+       dev-libs/boost:=[nls]
+       >=dev-libs/libpcre-8.42[cxx]
+       dev-libs/snowball-stemmer:=
+       net-misc/curl
+       dev-libs/libbson
+       dev-libs/mongo-c-driver:0
+       >=virtual/zlib-1.2.12:=
+       kerberos? ( dev-libs/cyrus-sasl[kerberos] )
+       ssl? (
+               >=dev-libs/openssl-1.0.1g:0=
+       )"
+DEPEND="${RDEPEND}
+       ${PYTHON_DEPS}
+       sys-libs/ncurses:0=
+       sys-libs/readline:0=
+       debug? ( dev-debug/valgrind )"
+BDEPEND="
+       $(python_gen_any_dep '
+               >=dev-build/scons-4.9.1[${PYTHON_USEDEP}]
+               dev-python/cheetah3[${PYTHON_USEDEP}]
+               dev-python/psutil[${PYTHON_USEDEP}]
+               dev-python/pyyaml[${PYTHON_USEDEP}]
+               dev-python/pymongo[${PYTHON_USEDEP}]
+       ')
+"
+PDEPEND="
+       mongosh? ( app-admin/mongosh-bin )
+       tools? ( >=app-admin/mongo-tools-100 )
+"
+
+PATCHES=(
+       "${WORKDIR}/mongodb-7.0.18-patches/mongodb-4.4.29-no-enterprise.patch"
+       "${WORKDIR}/mongodb-7.0.18-patches/mongodb-5.0.2-no-compass.patch"
+       "${WORKDIR}/mongodb-7.0.18-patches/mongodb-5.0.2-skip-reqs-check.patch"
+       "${WORKDIR}/mongodb-7.0.18-patches/mongodb-4.4.10-boost-1.81.patch"
+       "${WORKDIR}/mongodb-7.0.18-patches/extrapatch-sconstruct.patch"
+       "${WORKDIR}/mongodb-7.0.18-patches/mongodb-7.0.18-boost-1.85.patch"
+       "${FILESDIR}/mongodb-7.0.28-sconstruct.patch"
+)
+
+python_check_deps() {
+       python_has_version -b ">=dev-build/scons-4.9.1[${PYTHON_USEDEP}]" &&
+       python_has_version -b "dev-python/cheetah3[${PYTHON_USEDEP}]" &&
+       python_has_version -b "dev-python/psutil[${PYTHON_USEDEP}]" &&
+       python_has_version -b "dev-python/pyyaml[${PYTHON_USEDEP}]" &&
+       python_has_version -b "dev-python/pymongo[${PYTHON_USEDEP}]"
+}
+
+pkg_pretend() {
+       # Bug 809692 + 890294
+       if use amd64 && ! use cpu_flags_x86_avx; then
+               ewarn "MongoDB 5.0 requires use of the AVX instruction set."
+               ewarn "This ebuild will use 
--experimental-optimization=-sandybridge which"
+               ewarn "will result in an experimental build of MongoDB as per 
upstream."
+               ewarn 
"https://docs.mongodb.com/v5.0/administration/production-notes/";
+       fi
+
+       if [[ -n ${REPLACING_VERSIONS} ]]; then
+               if ver_replacing -lt 4.4; then
+                       ewarn "To upgrade from a version earlier than the 
4.4-series, you must"
+                       ewarn "successively upgrade major releases until you 
have upgraded"
+                       ewarn "to 4.4-series. Then upgrade to 5.0 series."
+               else
+                       ewarn "Be sure to set featureCompatibilityVersion to 
4.4 before upgrading."
+               fi
+       fi
+}
+
+src_prepare() {
+       default
+
+       # remove bundled libs
+       rm -r src/third_party/{boost,snappy-*,yaml-cpp} || die
+
+       # remove compass
+       rm -r src/mongo/installer/compass || die
+}
+
+src_configure() {
+       # bug #954813
+       filter-lto
+
+       # https://github.com/mongodb/mongo/blob/v7.0/docs/building.md
+       # --use-system-icu fails tests
+       # --use-system-tcmalloc is strongly NOT recommended:
+       # for MONGO_GIT_HASH use GitOrigin-RevId from the commit of the tag
+       scons_opts=(
+               AR="$(tc-getAR)"
+               CC="$(tc-getCC)"
+               CXX="$(tc-getCXX)"
+               CCFLAGS="${CXXFLAGS}"
+
+               VERBOSE=1
+               VARIANT_DIR=gentoo
+               MONGO_VERSION="${PV}"
+               MONGO_GIT_HASH="cfc346c59d2cc3dbc903507fc642e22e3097f362"
+
+               --disable-warnings-as-errors
+               --force-jobs # Reapply #906897, fix #935274
+               --jobs="$(makeopts_jobs)"
+               --use-system-boost
+               --use-system-snappy
+               --use-system-stemmer
+               --use-system-yaml
+               --use-system-zlib
+               --use-system-zstd
+       )
+
+       use arm64 && scons_opts+=( --use-hardware-crc32=off ) # Bug 701300
+       use amd64 && scons_opts+=( --experimental-optimization=-sandybridge ) # 
Bug 890294
+       use debug && scons_opts+=( --dbg=on )
+       use kerberos && scons_opts+=( --use-sasl-client )
+
+       scons_opts+=( --ssl=$(usex ssl on off) )
+
+       # Needed to avoid forcing FORTIFY_SOURCE
+       # Gentoo's toolchain applies these anyway
+       scons_opts+=( --runtime-hardening=off )
+
+       # gold is an option here but we don't really do that anymore
+       if tc-ld-is-lld; then
+                scons_opts+=( --linker=lld )
+       else
+                scons_opts+=( --linker=bfd )
+       fi
+
+       # respect mongoDB upstream's basic recommendations
+       # see bug #536688 and #526114
+       if ! use debug; then
+               filter-flags '-m*'
+               filter-flags '-O?'
+       fi
+
+       default
+}
+
+src_compile() {
+       PREFIX="${EPREFIX}/usr" ./buildscripts/scons.py "${scons_opts[@]}" 
install-devcore || die
+}
+
+src_install() {
+       dobin build/install/bin/{mongo,mongod,mongos}
+
+       doman debian/mongo*.1
+       dodoc docs/building.md
+
+       newinitd "${FILESDIR}/${PN}.initd-r3" ${PN}
+       newconfd "${FILESDIR}/${PN}.confd-r3" ${PN}
+       newinitd "${FILESDIR}/mongos.initd-r3" mongos
+       newconfd "${FILESDIR}/mongos.confd-r3" mongos
+
+       insinto /etc
+       newins "${FILESDIR}/${PN}.conf-r3" ${PN}.conf
+       newins "${FILESDIR}/mongos.conf-r2" mongos.conf
+
+       systemd_newunit "${FILESDIR}/${PN}.service-r1" "${PN}.service"
+
+       insinto /etc/logrotate.d/
+       newins "${FILESDIR}/${PN}.logrotate" ${PN}
+
+       # see bug #526114
+       pax-mark emr "${ED}"/usr/bin/{mongo,mongod,mongos}
+
+       diropts -m0750 -o mongodb -g mongodb
+       keepdir /var/log/${PN}
+}
+
+pkg_postinst() {
+       ewarn "Make sure to read the release notes and follow the upgrade 
process:"
+       ewarn "  https://docs.mongodb.com/manual/release-notes/$(ver_cut 1-2)/"
+       ewarn "  https://docs.mongodb.com/manual/release-notes/$(ver_cut 
1-2)/#upgrade-procedures"
+}

Reply via email to